package cz.muni.fi.pb162.encyclopedia;

/**
 * ZOO consists of the catalog of species (without duplicities)
 * and register of individualanimals.
 */
public interface Zoo
{
    
    /**
     * Adds a new species into the catalog of species.
     * 
     * @param sp Species name
     * @throws IllegalArgumentException if sp is null
     * @return null if species already exists in the catalog of species,
     *         instance of new species on success
     */
    Species addSpecies(String sp);
    
    /**
     * Adds a new animal to the ZOO. Species must already exist in the
     * catalog of species.
     * 
     * @param name Animal name
     * @param weight Animal weight
     * @param sp Species of the animal
     * @throws IllegalArgumentException if name or sp is null
     * @throws IllegalArgumentException weight <= 0
     * @return null if species does not exist in the catalog of species,
     *         instance of new animal on success
     */
    Animal addAnimal(String name, float weight, Species sp);

    /**
     * Prints all species into standard output.
     */
    void printSpecies();

    /**
     * Prints all animals of ZOO into standard output.
     */
    void printAnimals();
}
